poj 2396

2024-05-27 13:58
文章标签 poj 2396

本文主要是介绍poj 2396,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

       这道题是对有上下界网络流问题的第一次实践。这题不需要求最大流或最下流,只要判断是否存在可行流,如果存在输出这个可行流(根据题目中的这句话判断:And, by the way, no one really reads budget proposals anyway, so we'll just have to make sure that it sums up properly and meets all constraints.)。不过话虽这么说,但是不知道OJ能不能真的判断所有可行的情况。

        由于不需要求最大流或者最小流,所以构图然后运行一次最大流算法就好了(具体方法参考:http://blog.csdn.net/u011008379/article/details/38306477)。

        不得不说,这题构图十分麻烦,这主要是和标准输入数据的格式有关,实在要处理太多情况,不过不是很难处理,有耐心就好。

        此外,个人想提出一点对这道题的疑问:

        for(i=a1;i<=a2;i++){for(j=b1;j<=b2;j++) {if(ch=='='){  //if(up[i][j]<w||down[i][j]>w) return false;       up[i][j]=down[i][j]=w;                             }else if(ch=='>') down[i][j]=max(down[i][j],w+1);else  if(ch=='<') up[i][j]=min(up[i][j],w-1);                       }               }
        被注释的这句话是用来判断题目给出的条件是否存在矛盾的,应该没有写错,可是如果把注释去掉,那么就会WA,注释掉才AC,不知为何。如果有哪位大牛发现我的错误,希望告诉我一下,非常感激!

         最后感谢一下这篇文章:POJ2396 题解_forsona&Sona的POJ题解,因为这篇文章里提供了题目数据的链接(http://www.ida.liu.se/projects/progcontest/progsm/2003/),才让我发现这个错误的,真的很感谢。


代码(C++):

#include <cstdlib>
#include <iostream>
#include <queue>#define MAX_N 30
#define MAX_M 300
#define INF 2000000000
using namespace std;//#define LOCALstruct Edge{int from;   int to;int cap;int next;   
} edge[MAX_N*MAX_M*4];int head[MAX_M+MAX_N],up[MAX_M][MAX_N],down[MAX_M][MAX_N],n,m,c,level[MAX_M+MAX_N],sum;bool get_info()
{int count,r,p,w,a1,a2,b1,b2,i,j,k;char ch;      scanf("%d",&count);for(i=1;i<=m;i++){for(j=1;j<=n;j++){up[i][j]=INF;down[i][j]=0;             }             } for(k=0;k<count;k++){scanf("%d %d %c %d",&r,&p,&ch,&w);a1=a2=r,b1=b2=p;if(r==0) a1=1,a2=m;if(p==0) b1=1,b2=n;for(i=a1;i<=a2;i++){for(j=b1;j<=b2;j++) {if(ch=='='){  //if(up[i][j]<w||down[i][j]>w) return false;       up[i][j]=down[i][j]=w;                             }else if(ch=='>') down[i][j]=max(down[i][j],w+1);else  if(ch=='<') up[i][j]=min(up[i][j],w-1);                       }               }               } return true;         
}void add_edge(int u,int v,int cap)
{edge[c].from=u;edge[c].to=v;edge[c].cap=cap;edge[c].next=head[u];head[u]=c;c++;edge[c].from=v;edge[c].to=u;edge[c].cap=0;edge[c].next=head[v];head[v]=c;c++;
}bool build_graph()
{int i,j;for(i=1;i<=m;i++){for(j=1;j<=n;j++){if(up[i][j]<down[i][j]) return false;add_edge(i,j+200,up[i][j]-down[i][j]); add_edge(i,n+200+3,down[i][j]);add_edge(n+200+2,j+200,down[i][j]);  sum+=down[i][j];          }             }add_edge(n+200+1,0,INF);return true;
}void bfs(int s)
{int i,v,u;queue<int> qi;level[s]=0;qi.push(s);while(!qi.empty()){u=qi.front();qi.pop();for(i=head[u];i!=-1;i=edge[i].next) {v=edge[i].to;if(edge[i].cap>0&&level[v]==-1){level[v]=level[u]+1;qi.push(v);           }                             }           }
}int dfs(int u,int t,int f)
{int i,v,d,res;if(u==t) return f;res=0;for(i=head[u];i!=-1;i=edge[i].next){v=edge[i].to;if(level[u]==level[v]-1&&edge[i].cap>0){d=dfs(v,t,min(f-res,edge[i].cap));if(d>0){edge[i].cap-=d;edge[i^1].cap+=d;res+=d;if(res==f) return res;   }                                   }                              }return res;
}int dinic(int s,int t)
{int flow,f;flow=0;while(1){memset(level,-1,sizeof(level));    bfs(s); if(level[t]==-1) return flow; f=dfs(s,t,INF);flow+=f;  }
}int main(int argc, char *argv[])  //超级源点:0,超级汇点:n+200+1,临时源点:n+200+2,临时汇点:n+200+3 
{                                 //expense标号:1~m    site标号:200~n+200 
#ifdef LOCALfreopen("in.txt","r",stdin);freopen("out.txt","w",stdout);
#endifint i,j,t,s,f,u,v;scanf("%d",&t); while(t--){scanf("%d %d",&m,&n);c=0;memset(head,-1,sizeof(head));sum=0;for(i=1;i<=m;i++){scanf("%d",&s); sum+=s;           add_edge(0,n+200+3,s);add_edge(n+200+2,i,s);            }for(i=1;i<=n;i++){scanf("%d",&s);sum+=s;add_edge(i+200,n+200+3,s);add_edge(n+200+2,n+200+1,s);          }if(!get_info()||!build_graph()){printf("IMPOSSIBLE\n\n");continue;              } f=dinic(n+200+2,n+200+3);if(f==sum){          for(i=(n+m)*4;i<c-2;i+=6){u=edge[i].from;v=edge[i].to;v-=200; down[u][v]+=edge[i+1].cap;        }      for(i=1;i<=m;i++){printf("%d",down[i][1]);              for(j=2;j<=n;j++){printf(" %d",down[i][j]);            }printf("\n");              }       }else printf("IMPOSSIBLE\n"); if(t>0) printf("\n");  }system("PAUSE");return EXIT_SUCCESS;
}

题目( http://poj.org/problem?id=2396):

Budget
Time Limit: 3000MS Memory Limit: 65536K
    Special Judge

Description

We are supposed to make a budget proposal for this multi-site competition. The budget proposal is a matrix where the rows represent different kinds of expenses and the columns represent different sites. We had a meeting about this, some time ago where we discussed the sums over different kinds of expenses and sums over different sites. There was also some talk about special constraints: someone mentioned that Computer Center would need at least 2000K Rials for food and someone from Sharif Authorities argued they wouldn't use more than 30000K Rials for T-shirts. Anyway, we are sure there was more; we will go and try to find some notes from that meeting. 

And, by the way, no one really reads budget proposals anyway, so we'll just have to make sure that it sums up properly and meets all constraints.

Input

The first line of the input contains an integer N, giving the number of test cases. The next line is empty, then, test cases follow: The first line of each test case contains two integers, m and n, giving the number of rows and columns (m <= 200, n <= 20). The second line contains m integers, giving the row sums of the matrix. The third line contains n integers, giving the column sums of the matrix. The fourth line contains an integer c (c < 1000) giving the number of constraints. The next c lines contain the constraints. There is an empty line after each test case. 

Each constraint consists of two integers r and q, specifying some entry (or entries) in the matrix (the upper left corner is 1 1 and 0 is interpreted as "ALL", i.e. 4 0 means all entries on the fourth row and 0 0 means the entire matrix), one element from the set {<, =, >} and one integer v, with the obvious interpretation. For instance, the constraint 1 2 > 5 means that the cell in the 1st row and 2nd column must have an entry strictly greater than 5, and the constraint 4 0 = 3 means that all elements in the fourth row should be equal to 3.

Output

For each case output a matrix of non-negative integers meeting the above constraints or the string "IMPOSSIBLE" if no legal solution exists. Put  one empty line between matrices.

Sample Input

22 3 
8 10 
5 6 7 
4 
0 2 > 2 
2 1 = 3 
2 3 > 2 
2 3 < 5 2 2 
4 5 
6 7 
1 
1 1 > 10

Sample Output

2 3 3 
3 3 4 IMPOSSIBLE 

这篇关于poj 2396的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1007671

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i